<?php
/**
 * @copyright (C)2014 Cenwor Inc.
 * @author Cenwor <www.cenwor.com>
 * @package php
 * @name callback.logic.php
 * @date 2015-09-11 16:54:02
 */





class CallbackLogic
{
	
	
	public function Parser($trade)
	{
		$data = $this->Trade2SID($trade);
		return loadInstance('logic.callback.parser.'.$data['sid'], $data['class_Parser']);
	}
	
	public function Bridge($trade)
	{
		$data = $this->Trade2SID($trade);
		return loadInstance('logic.callback.bridge.'.$data['sid'], $data['class_Bridge']);
	}
	
	private function Trade2SID($trade)
	{
		$sign = is_numeric($trade) ? $trade : $trade['sign'];
		$idx = substr($sign, 0, 1);
		if ($idx == 2)
		{
			return array(
				'sid' => 'order',
				'class_Parser' => 'Order_Parser_CallbackLogic',
				'class_Bridge' => 'Order_Bridge_CallbackLogic'
			);
		}
		elseif ($idx == 3)
		{
			return array(
				'sid' => 'recharge',
				'class_Parser' => 'Recharge_Parser_CallbackLogic',
				'class_Bridge' => 'Recharge_Bridge_CallbackLogic'
			);
		}
		else
		{
			return array(
				'sid' => 'default',
				'class_Parser' => 'Default_Parser_CallbackLogic',
				'class_Bridge' => 'Default_Bridge_CallbackLogic'
			);
		}
	}

	
	
	protected $master = null;
	
	public function MasterIframe($object)
	{
		$this->master = $object;
	}
}



class Order_Parser_CallbackLogic extends CallbackLogic
{
	
	private $message = true;

	
    public function Virtual_Order_Process($payment = false, $trade = array(), $status = '') {
        $this->message = false;
        if($payment && $trade && $status) {
        	$status_default = $status;
        	    		logic('order')->virtual_order_data_fix($trade['sign']);
        	$orders = logic('order')->getAllOrdersByOrderid($trade['sign']);
        	if(is_array($orders) && count($orders)) {
        		foreach($orders as $order) {
        			$status = $status_default;
        			        			if(in_array($status, array('WAIT_SELLER_SEND_GOODS','__CREATE__')) &&
        				($product = logic('product')->SrcOne($order['productid'])) && 
        				'ticket' == $product['type']) {
        				$status = 'TRADE_FINISHED';
        			} 
					
										if (in_array($status, array('WAIT_SELLER_SEND_GOODS', 'FINISHED')) && logic('yungou')->isYunGouOrder($order['orderid'])) {						
						$this->parse_yunGouPayment($payment, $order, $status);
					} else {						
						$method = 'Parse_' . $status;
						if(method_exists($this, $method)) {
							$this->$method($payment, $order);
						} else {
							exit('method error');
        				}						
					}
        		}
        	}
                                }
        $this->master->Messager(__('νѾɣ'), '?mod=me&code=order');        
    }

    
	
	function Parse_VERIFY_FAILED($payment = false, $order = array())
	{
				if (logic('pay')->Process($payment, 'VERIFY_FAILED')) return;
 		$this->message && $this->master->Messager(__('֧֤ʧܣ'), '?mod=me&code=order');
	}
	
	function Parse_WAIT_BUYER_PAY($payment = false, $order = array())
	{
				if(logic('pay')->Process($payment, 'WAIT_BUYER_PAY')) return;
		$this->message && $this->master->Messager(__('Ѿɣ뾡츶'), '?mod=me&code=order');
	}
	
	function Parse_WAIT_SELLER_SEND_GOODS($payment = false,$order = array())
	{
				$trade = logic('pay')->TradeData($payment,$order);
		if (logic('yungou')->isYunGouOrder($trade['sign'])) {
			$this->parse_yunGouPayment($payment, $order, 'WAIT_SELLER_SEND_GOODS');
			return ;
		}
		$order = logic('order')->_TMP_Payed($trade, $payment);
		$error = false;
		isset($order['false']) && $error = $order['false'];
        
		if (!$error)
		{
			if ($order['product']['type'] == 'ticket')
			{
								logic('pay')->vSendGoods($order);
				if (true == ini('payment.trade.sendgoodsfirst'))
				{
										logic('order')->MakeSuccessed($trade['sign']);
					logic('order')->Processed($trade['sign'], 'WAIT_BUYER_CONFIRM_GOODS');
					logic('order')->clog($trade['sign'])->sys(TUANGOU_STR . 'ȯз͸ûȴûȷջ', 'WAIT_BUYER_CONFIRM_GOODS');
				}
				else
				{
										notify($order['userid'], 'user.pay.confirm', $trade);
				}
			}
			else
			{
				$isCOD = $trade['nmpay'];
								$isCOD && logic('order')->Update($trade['sign'], array('pay' => ORD_PAID_Yes, 'process' => '__PAY_YET__'));
								logic('order')->MakeSuccessed($trade['sign']);
								$isCOD && logic('order')->Update($trade['sign'], array('pay' => ORD_PAID_No, 'process' => 'WAIT_SELLER_SEND_GOODS'));
			}
		}
		else
		{
			if ($order['_tmpd_']['paid'])
			{
				logic('order')->Update($trade['sign'], array('status'=>ORD_STA_Overdue,'process'=>'__PAY_YET__'));
				logic('order')->clog($trade['sign'])->sys('ʧܣѱΪڣ'.$error, '__PAY_YET__');
								if ($order['_tmpd_']['money'] > 0 && $trade['money'] > 0)
				{
										logic('me')->money()->less($trade['price'], $order['userid'], array(
						'name' => __('Ч'),
						'intro' => sprintf(__('ţ%s<br/>׵ţ%s<br/><b>׽ӿ֧ʽδЧ뵽֧ƽ̨˿</b>'), $order['orderid'], $trade['trade_no'])
					));
				}
			}
		}
		if(logic('pay')->Process($payment, 'WAIT_SELLER_SEND_GOODS')) return;
		$this->message && $this->master->Messager($error?$error:__('ѾύǻᾡΪ׼'), '?mod=me&code=order');
		return $error;
	}
	
	function Parse_WAIT_BUYER_CONFIRM_GOODS($payment = false,$order = array())
	{
				$trade = logic('pay')->TradeData($payment,$order);
		if (logic('recharge')->forder()->paid($trade['sign']))
		{
			logic('order')->Processed($trade['sign'], 'WAIT_BUYER_CONFIRM_GOODS');
			logic('order')->clog($trade['sign'])->sys('֧ƽ̨֪ͨȴȷջ', 'WAIT_BUYER_CONFIRM_GOODS');
		}
		if(logic('pay')->Process($payment, 'WAIT_BUYER_CONFIRM_GOODS')) return;
		$this->message && $this->master->Messager(__('Ѿϣյ󾡿ȷջ'), '?mod=me&code=order');
	}
	
	function Parse_TRADE_FINISHED($payment = false,$order = array())
	{
				$trade = logic('pay')->TradeData($payment,$order);
		if (logic('yungou')->isYunGouOrder($trade['sign'])) {
			$this->parse_yunGouPayment($payment, $order, 'TRADE_FINISHED');
			return ;
		}
		$order = logic('order')->_TMP_Payed($trade);
		$error = false;
		isset($order['false']) && $error = $order['false'];
		if (!$error)
		{
			if ($order['process'] == 'WAIT_BUYER_CONFIRM_GOODS')
			{
												logic('order')->Processed($trade['sign'], '__PAY_YET__');
				logic('order')->clog($trade['sign'])->sys('ϵͳڲ״ûѸ', '__PAY_YET__');
				$order['product']['type'] == 'stuff' && $ups2TRADE_FINISHED = true;
			}
			$order = logic('order')->MakeSuccessed($trade['sign']);
						if ($ups2TRADE_FINISHED)
			{
				logic('order')->Processed($trade['sign'], 'TRADE_FINISHED');
				logic('order')->clog($trade['sign'])->sys('ϵͳڲ״', 'TRADE_FINISHED');
				
		        		        logic('rebate')->Add_Rebate_For_Item($order);
		        			}
		}
		else
		{
			if ($order['_tmpd_']['paid'])
			{
				logic('order')->Update($trade['sign'], array('status'=>ORD_STA_Overdue,'process'=>'__PAY_YET__'));
				logic('order')->clog($trade['sign'])->sys('ʧܣѱΪڣ'.$error, '__PAY_YET__');
			}
		}
		if(logic('pay')->Process($payment, 'TRADE_FINISHED')) return;
		$this->message && $this->master->Messager($error?$error:__('νѾɣ'), '?mod=me&code=order');
	}
	
	
	public function parse_yunGouPayment($payment = false,$order = array(), $sourceStatus = '') 
	{
				$trade = logic('pay')->TradeData($payment,$order);
		$order = logic('order')->_TMP_Payed($trade, $payment);			
		$error = false;																if (isset($order['false'])) {
			$error = $order['false'];
		}
		
		if (!$error)
		{
			
			 
						if('WAIT_RESULT' != $order['process']) { 				 
				 				 for ($i = 0; $i < $order['productnum']; $i++) {						 
					 logic('yungou')->addCanYuJiLu($order['productid'], $order['orderid'], $order['userid'], $i);
					 
				 }

				 logic('order')->baseUpdate(array('process' => 'WAIT_RESULT'), 'orderid = "' . $trade['sign'] . '"');
			}
			 
			 			 $sellsCount = logic('product')->SellsCount($order['productid']);
			 logic('product')->Update_direct($order['productid'], array('sells_count' => $sellsCount));
			 
			 			 if (logic('yungou')->isYunGouSoldOut($order['productid'])) {
				 
				 
				 logic('product')->Update($order['productid'], array('overtime' => time(),
				 													 'status' => PRO_STA_Finish,
				 													 'yungou' => YUNGOU_STA_Readied));
				 
			 }
			 
			 
		}
		else
		{
			if ($order['_tmpd_']['paid'])
			{
				logic('order')->Update($trade['sign'], array('status'=>ORD_STA_Overdue,'process'=>'__PAY_YET__'));
				logic('order')->clog($trade['sign'])->sys('ʧܣѱΪڣ'.$error, '__PAY_YET__');
				
				if ($sourceStatus == 'WAIT_SELLER_SEND_GOODS') {
										if ($order['_tmpd_']['money'] > 0 && $trade['money'] > 0)
					{
												logic('me')->money()->less($trade['price'], $order['userid'], array(
							'name' => __('Ч'),
							'intro' => sprintf(__('ţ%s<br/>׵ţ%s<br/><b>׽ӿ֧ʽδЧ뵽֧ƽ̨˿</b>'), $order['orderid'], $trade['trade_no'])
						));
					}
				}
			}
		}
		
				if(logic('pay')->Process($payment, $sourceStatus)) {
			return;
		}
		
		$this->message && $this->master->Messager($error?$error:__('Ѿύȴ'), '?mod=me&code=order');
		
		return $error;
	}
}


class Order_Bridge_CallbackLogic extends CallbackLogic
{
	
	public function SrcOne($orderid, $more = false)
	{
		if($more) {
			return logic('order')->GetOne($orderid);
		} else {
			return logic('order')->SrcOne($orderid);
		}
	}
	
	public function Processed($sign, $process)
	{
		return logic('order')->Processed($sign, $process);
	}
}


class Recharge_Parser_CallbackLogic extends CallbackLogic
{
	
	function Parse_VERIFY_FAILED($payment = false)
	{
				if (logic('pay')->Process($payment, 'VERIFY_FAILED')) return;
		$this->master->Messager(__('֧֤ʧܣ'), '?mod=me&code=bill');
	}
	
	function Parse_WAIT_BUYER_PAY($payment = false)
	{
				if(logic('pay')->Process($payment, 'WAIT_BUYER_PAY')) return;
		$this->master->Messager(__('Ѿɣ뾡츶'), '?mod=me&code=bill');
	}
	
	function Parse_WAIT_SELLER_SEND_GOODS($payment = false)
	{
				$trade = logic('pay')->TradeData($payment);
		$order = logic('recharge')->ccOrder($trade['sign']);
				logic('pay')->vSendGoods($order);
		if(logic('pay')->Process($payment, 'WAIT_SELLER_SEND_GOODS')) return;
		$confirmLinker = logic('pay')->ConfirmLinker($order);
		$this->master->Messager(__('ʹ˵׽ӿڣȥȷջϵͳԶΪֵ'), $confirmLinker, 5);
	}
	
	function Parse_WAIT_BUYER_CONFIRM_GOODS($payment = false)
	{
				$trade = logic('pay')->TradeData($payment);
		$order = logic('recharge')->ccOrder($trade['sign']);
		if(logic('pay')->Process($payment, 'WAIT_BUYER_CONFIRM_GOODS')) return;
		$confirmLinker = logic('pay')->ConfirmLinker($order);
		$this->master->Messager(__('ʹ˵׽ӿڣȥȷջϵͳԶΪֵ'), $confirmLinker, 5);
	}
	
	function Parse_TRADE_FINISHED($payment = false)
	{
				$trade = logic('pay')->TradeData($payment);
		if($trade['sign'] && true === (logic('recharge')->MakeSuccessed($trade['sign']))) {
			if(logic('pay')->Process($payment, 'TRADE_FINISHED')) return;
			$this->master->Messager(__('ѳֵɹ'), '?mod=me&code=bill');
		}
	}
}


class Recharge_Bridge_CallbackLogic extends CallbackLogic
{
	
	public function SrcOne($orderid, $more = null)
	{
		return logic('recharge')->ccOrder($orderid);
	}
	
	public function Processed($sign, $process)
	{

	}
}


class Default_Parser_Callbacklogic extends CallbackLogic
{

}

class Default_Bridge_CallbackLogic extends CallbackLogic
{
	public function SrcOne($sign, $more = null)
	{
		return array();
	}
}
?>