<?php

/**
 * ߼ֻ֤
 * @copyright (C)2011 Cenwor Inc.
 * @author <foxis@qq.com>
 * @package logic
 * @name phone.logic.php
 * @version 1.0
 */

class PhoneLogic
{
	public function view($phone = null) {
		$phone = (is_null($phone) ? user()->get('phone') : $phone);
		return ($phone ? substr($phone, 0, 3) . '****' . substr($phone, -4) : '');
	}

	
	public function GetOne($key, $val, $vfd = false)
	{
		if(false == in_array($key, array('id', 'uid', 'phone'))) {
			return false;
		}
		$val = (is_numeric($val) ? $val : 0);
		if(empty($val)) {
			return false;
		}
		$q = dbc(DBCMax)->select('phone')->where(array($key=>$val));
		$vfd && $q->where('vftime>0');
		return $q->order(' `id` DESC ')->limit(1)->done();
	}
	public function Checkip($num = 15) {		
		$num = max(0, (int) $num, (int) ini('settings.phone_checkip_nums'));
		if($num > 0) {
			$ip = client_ip();
			if($ip) {
				$timezero = strtotime(date('Y-m-d',time()));
				$row = dbc()->query("SELECT COUNT(1) AS MDCS FROM ".table('push_log')." WHERE `userip`= '$ip' and `type`='sms' and `update`>=$timezero")->GetRow();
				if ($row['MDCS'] > $num) {
					 return  'עޣ';
				}
			}
		}
	}
	public function Check($phone, $check_exists = true, $check_ip = false) {
		if($check_ip && false != ($ret = $this->Checkip())) {
			return $ret;
		}

		$phone = (is_numeric($phone) ? (string) $phone : 0);
		if(empty($phone)) {
			return 'ֻŲΪ';
		}
		if(11 != strlen($phone)) {
			return '11λֻ';
		}
		if(false == preg_match('~^1(3|4|5|7|8)[0-9]{9}$~', $phone)) {
			return 'ȷֻ';
		}
		if(false !== $check_exists) {
			$uid = ((is_numeric($check_exists) && $check_exists > 0) ? $check_exists : ((defined('MEMBER_ID') && MEMBER_ID > 0) ? MEMBER_ID : user()->get('id')));
			
			$phone_members = dbc(DBCMax)->select('members')->where(array('phone'=>$phone))->limit(1)->done();
			if($phone_members && $phone_members['phone_validate']) {
				if($uid > 0 && $uid == $phone_members['uid']) {
					;
				} else {
					return 'ֻѾ˻';
				}
			}
			$username_members = dbc(DBCMax)->select('members')->where(array('username'=>$phone))->limit(1)->done();
			if($username_members) {
				if($uid > 0 && $uid == $username_members['uid']) {
					;
				} else {
					return 'ֻѾ˻';
				}
			}
		}
		return ;
	}
	
	public function VfSend($phone, $uid = 0)
	{
		$phone = (is_numeric($phone) ? (string) $phone : 0);
		if(false != ($ret = self::Check($phone, $uid))) {
			return $ret;
		}

		$res = $this->GetOne('phone', $phone);
		$resID = 0;
		$uid === 0 && $uid = user()->get('id');

		$userData = array('uid' => (int) $uid, 'phone' => $phone);
		if ($res)
		{
			if($res['stime'] + 60 > time())
			{
				return 'ոѾ͹ˣ60ԣ';
			}
			
			$resID = $res['id'];
		}
		else
		{
			$res = dbc(DBCMax)->select('phone')->where($userData)->order(' `id` DESC ')->limit(1)->done();
			if($res)
			{
				if($res['stime'] + 60 > time())
				{
					return 'ոѾ͹ˣ60ԣ';
				}
				$resID = $res['id'];
			}
			else
			{
				$resID = dbc(DBCMax)->insert('phone')->data($userData)->done();
			}
		}

		if(false == $resID) {
			return 'δ֪󣬼¼дʧ';
		}

				$vfCode = mt_rand(100000, 999999);
		$this->update($resID, array_merge($userData, array('stime'=>time(), 'vfcode'=>$vfCode, 'vftime'=>0, 'vftimes'=>0)));

		

						$sms = '֤Ϊ'.$vfCode.'15Ч';
				logic('push')->addi('sms', $phone, array('content'=>$sms));

		return ;
	}
	
	public function Vfcode($phone, $vfcode, $uid = 0)
	{
		$uid === 0 && $uid = user()->get('id');
		$phone = (is_numeric($phone) ? (string) $phone : 0);
		if(false != ($ret = self::Check($phone, false))) {
			return $ret;
		}

		if(empty($vfcode))
		{
			return 'ֻ֤벻Ϊ';
		}

		$res = $this->GetOne('phone', $phone);
		if (!$res)
		{
			return 'ֻ뻹δ͹֤';
		}

				$this->update($res['id'], array(
				'vftimes' => $res['vftimes'] + 1,
			));

		if($res['stime'] > 0 && $res['stime'] + 900 < time())
		{
			return '֤볬ʱ·֤';
		}
		if($res['vftimes'] > 10)
		{
			return '֤࣬·֤';
		}
		
		if ($res['vfcode'] != $vfcode)
		{
			return '֤';
		}

				$this->update($res['id'], array(
				'uid' => $uid,
				'vftime' => time(),
				'vfcode' => '',
			));

		if($uid > 0) {
			return self::bind($phone, $uid);
		}

		return ;
	}

	public function update($id, $data = array())
	{
		$ret = false;
		$id = (is_numeric($id) ? $id : 0);
		if($id > 0 && $data) {
			$row = $this->GetOne('id', $id);
			if($row) {
				$ret = dbc(DBCMax)->update('phone')->data($data)->where(array('id' => $id))->done();
			}
		}
		return $ret;
	}

	
	public function bind($phone, $uid, $check = true) {
		$uid = (is_numeric($uid) ? $uid : 0);
		$phone = (is_numeric($phone) ? $phone : 0);

		if($phone && $uid > 0) {
			if(false != $check && false != ($ret = self::Check($phone, $uid))) {
				return $ret;
			}

			$where = array('phone'=>$phone, 'uid'=>$uid,);
			$rets = dbc(DBCMax)->select('phone')->where($where)->done();
			$data = array_merge($where, array('btime'=>time()));
			if(1 === count($rets) && $rets[0]['id'] > 0)  {
				$this->update($rets[0]['id'], $data);
			} else {
				$this->unbind($phone, $uid);
				dbc(DBCMax)->insert('phone')->data($data)->done();
			}

			dbc(DBCMax)->update('members')->data(array('phone' => '', 'phone_validate' => 0))->where(array('phone' => $phone))->done();
			dbc(DBCMax)->update('members')->data(array('phone' => $phone, 'phone_validate' => 1))->where(array('uid' => $uid))->done();

			logic('prize')->bind($phone, $uid);
		}

		return ;
	}

	
	public function unbind($phone, $uid = 0) {
		$phone = (is_numeric($phone) ? $phone : 0);
		dbc(DBCMax)->delete('phone')->where(array('phone' => $phone))->done();

		dbc(DBCMax)->update('members')->data(array('phone' => '', 'phone_validate' => 0))->where(array('phone' => $phone))->done();

		$uid = (is_numeric($uid) ? $uid : 0);
		if($uid > 0) {
			dbc(DBCMax)->delete('phone')->where(array('uid' => $uid))->done();

			dbc(DBCMax)->update('members')->data(array('phone' => '', 'phone_validate' => 0))->where(array('uid' => $uid))->done();
		}

		dbc(DBCMax)->delete('phone')->where(" `uid`='0' AND `stime`<'" . (time() - 1000) . "' ")->done();

		logic('prize')->unbind($phone, $uid);
	}

	public function rebind2($uid = 0) {
		return self::rebind($uid, 'phone');
	}
	public function dorebind2($oldphone, $phone, $vfcode, $uid = 0) {
		return self::dorebind($oldphone, $phone, $vfcode, $uid, 'phone');
	}

	public function rebind($uid = 0, $checkby = 'email') {
		$uid = (is_numeric($uid) ? $uid : 0);
		$uid === 0 && $uid = user()->get('id');
		if($uid < 1) {
			return 'ûUIDΪ';
		}

		$user = user($uid)->get();
		if(empty($user)) {
			return 'ûѾ';
		}

		if(empty($user['phone']) || false == $user['phone_validate']) {
			return 'δֻ';
		}

		$member = $this->__member($uid);
		if(false == $member) {
			return 'ûѾ!';
		}

		if('phone' == $checkby) {
			return ;
		}

		if(empty($user['email']) || false == $user['checked']) {
			return 'δ֤ͨϵվԱ';
		}

		$timestamp=time();
        if ($member['authstr']) {
            list($dateline, $operation, $idstring) = explode("|", $member['authstr']);
            $inteval=300;            if ($dateline+$inteval>$timestamp) {
                return "벻ҪظⷢͣѾ͵У⣬վԱϵ";
            }
        }

        $mvfcode = random(8, 1);
        $member['authstr'] = "$timestamp|1|$mvfcode";
        $member['auth_try_times'] = 0;
        dbc()->SetTable(TABLE_PREFIX.'system_memberfields');
        $result=dbc()->Update($member,"uid={$member['uid']}");
        if ($result==false)
        {
            dbc()->Insert($member);
        }
        $onlineip=$_SERVER['REMOTE_ADDR'];
        $settings = ini('settings');
                $email_message=" {$settings['site_name']} ֤ $mvfcode 30Ч ֤й©ˣ
<br/>
ύߵ IP Ϊ $onlineip<br/>
<br/><br/>
{$settings['site_url']}";
        $subject="[{$settings['site_name']}] ֤";

        logic('service')->mail()->Send($member['email'], $subject, $email_message);

		return ;
	}

	public function dorebind($mvfcode, $phone, $vfcode, $uid = 0, $checkby = 'email') {
		$uid = (is_numeric($uid) ? $uid : 0);
		$uid === 0 && $uid = user()->get('id');
		if($uid < 1) {
			return 'ûUIDΪ';
		}

		$phone = (is_numeric($phone) ? (string) $phone : 0);
		if(false != ($ret = self::Check($phone, false))) {
			return $ret;
		}

		if(empty($vfcode)) {
			return 'ֻ֤벻Ϊ';
		}

		$user = user($uid)->get();
		if(empty($user)) {
			return 'ûѾ';
		}

		if(empty($user['phone']) || false == $user['phone_validate']) {
			return 'δֻ';
		}

		if($user['phone'] == $phone) {
			return 'ֻһģûб仯';
		}

		$member = $this->__member($uid);
		if(false == $member) {
			return 'ûѾ!';
		}

		if('phone' == $checkby) {
			if($mvfcode != $user['phone']) {
				return 'ԭȰ󶨵ֻ';
			}
		} else {
			if(empty($mvfcode)) {
				return 'ʼ֤벻Ϊ';
			}

			if(empty($user['email']) || false == $user['checked']) {
				return 'δ֤ͨϵվԱ';
			}

			$member['auth_try_times'] = (max(0, (int) $member['auth_try_times']) + 1);
	        dbc(DBCMax)->Update('memberfields')->data(array('auth_try_times'=>$member['auth_try_times']))->where(array('uid'=>$uid))->done();
	        if($member['auth_try_times']>=10) {
	        	return 'ԵĴ̫ˣ·!';
	        }

	        $timestamp=time();
	        list($dateline, $operation, $idstring) = explode("|", $member['authstr']);
	        if($dateline < $timestamp - 1000 || $operation != 1 || $idstring != $mvfcode) {
	        	return 'ʼ֤Ѿˣ·!';
	        }
	    }

        $ret = $this->Vfcode($phone, $vfcode, $uid);
        if($ret) {
        	return $ret;
        }

        self::unbind($user['phone']);

        if('email' == $checkby) {
        	dbc(DBCMax)->Update('memberfields')->data(array('auth_try_times'=>0, 'authstr' => ''))->where(array('uid'=>$uid))->done();
        }

        return ;
	}

	public function clear_invalid($uids = array()) {
		settype($uids, 'array');
		$query = dbc()->query("SELECT p.uid FROM ".table('phone')." p LEFT JOIN ".table('members')." m ON m.uid=p.uid WHERE m.uid IS NULL");
		while(false != ($row = $query->GetRow())) {
			$uids[$row['uid']] = $row['uid'];
		}
		if($uids) {
			dbc()->query("DELETE FROM ".table('phone')." WHERE uid IN ('".implode("','", $uids)."')");
		}
	}
	private function __member($uid) {
		$uid = (is_numeric($uid) ? $uid : 0);
		if($uid < 1) {
			return false;
		}

		$sql="
        SELECT
            M.uid,M.username,M.email,M.email2,M.secques,MF.uid as fuid,MF.authstr,MF.auth_try_times
        FROM
            ".TABLE_PREFIX. 'system_members'." M LEFT JOIN ".TABLE_PREFIX.'system_memberfields'." MF ON(M.uid=MF.uid)
        WHERE
            BINARY M.uid='$uid'";
		return dbc(DBCMax)->query($sql)->limit(1)->done();
	}

}

?>
