<?php
/**
 * @copyright (C)2014 Cenwor Inc.
 * @author Cenwor <www.cenwor.com>
 * @package php
 * @name rebate.logic.php
 * @date 2015-09-23 18:07:18
 */



class RebateLogic
{
	private $time = 0;

	
	public function Get_HomeInfo_For_Seller($sellerid)
	{
		$res = dbc(DBCMax)->select('seller')->where('`id`='. (int)$sellerid)->limit(1)->done();
		if( $res ){
			$arr = $this->Get_HomeInfo_For_member($res['userid']);
			$arr['profit_pre'] = $res['profit_pre'];
			return $arr;
		}else{
			return 0;
		}
	}
	public function Get_HomeInfo_For_member($userid)
	{
		$res = dbc(DBCMax)->select('members')->where('`uid`='. (int)$userid)->limit(1)->done();
		if( !$res ) return 0;
		$home_uid = $res['home_uid'];
		$uname    = $res['username'];
		if( $home_uid==0 ){
			return array(
				'userid' => $userid,
				'uname'=>$uname,
			);
		}
		$res = dbc(DBCMax)->select('members')->where('`uid`='. (int)$home_uid)->limit(1)->done();
		if( $res ){
			return array(
				'userid' => $userid,
				'uname'=>$uname,
				'home_uid'=>$res['uid'],
				'buy_pre'=>$res['buy_pre'],
				'sell_pre'=>$res['sell_pre'],
			);
		}else{
			return array(
				'userid' => $userid,
				'uname'=>$uname,
			);
		}
	}
	public function Add_RebateValue_For_Seller($sellerid,$money,$orderid,$ticketid=0,$fundmoney=0){
		$ret = false;
		$sellerid = (int) $sellerid;
		$money = (float) $money;
		$orderid = (is_numeric($orderid) ? $orderid : 0);
		$ticketid = (is_numeric($ticketid) ? $ticketid : 0);
		$fundmoney = (float) $fundmoney;

		$home = $this->Get_HomeInfo_For_Seller($sellerid);

		if( !$home ) {
			return $ret;
		}

		$time = ($this->time > 0 ? $this->time : time());

				$userid     = $home['userid'];
		$dr_set = ini('rebate_setting');
						if(1) {
			$profit_pre = ($home['profit_pre'] > 0 ? $home['profit_pre'] : (($dr_set['profit'] && $dr_set['profit'][0]['pre'] > 0) ? $dr_set['profit'][0]['pre'] : 0));
			$data = array(
				'uid'      => $userid,
				'uname' => $home['uname'],
				'home_uid' => 0,
				'deal_money' => $money,
				'fund_money' => $fundmoney,
				'salary_pre' => $profit_pre,
				'salary_money' => $this->gave_me_money($money, $profit_pre),
				'orderid' => $orderid,
				'ticketid' => $ticketid,
				'type' => 'master',
				'addtime' => $time,
				'rec_all' => 1,
			);
			if(false == $this->_check_exists($data)) {
				$ret = true;
				dbc(DBCMax)->insert('rebate_log')->data($data)->done();
								if($fundmoney >= 0){
					$salary_money = $fundmoney;
				}elseif($profit_pre > 0){
					$salary_money = $money - $this->gave_me_money($money, $profit_pre);
				}else{
					$salary_money = $money;
				}
				dbc(DBCMax)->update('seller')->data('account_money=account_money+'. $salary_money .',total_money=total_money+'. $salary_money )->where('id='.(int)$sellerid)->done();
			}
		}
				if( !$home['home_uid'] ) {
			return $ret;
		}
		$salary_pre = ($home['sell_pre'] > 0 ? $home['sell_pre'] : (($dr_set['sell_pre'] && $dr_set['sell_pre'] > 0) ? $dr_set['sell_pre'] : 0));
		if($salary_pre > 0){
			$salary_money = $this->gave_me_money($money, $salary_pre);
			$home_uid   = $home['home_uid'];
			$data = array(
				'uid'      => $userid,
				'uname' => $home['uname'],
				'home_uid' => $home_uid,
				'deal_money' => $money,
				'salary_pre' => $salary_pre,
				'salary_money' => $salary_money,
				'orderid' => $orderid,
				'ticketid' => $ticketid,
				'type' => 'sell',
				'addtime' => $time,
			);
			if(false == $this->_check_exists($data)) {
				$ret = true;
				dbc(DBCMax)->insert('rebate_log')->data($data)->done();
				logic('me')->money()->add($salary_money, $home_uid, array(
					'name' => '뷵',
					'intro' => "ҡ".$home['uname']."ڣ".date('Y-m-d H:i:s', $time)."<br>Ʒ".$money."Ԫ÷".$salary_money."Ԫ<br>ţ".$orderid
				));
			}
		}
		return $ret;
	}
	public function Add_RebateValue_For_Buyer($userid,$money,$orderid='',$ticketid=0){
		$ret = false;
		$userid = (int) $userid;
		$money = (float) $money;
		$orderid = (is_numeric($orderid) ? $orderid : 0);
		$ticketid = (is_numeric($ticketid) ? $ticketid : 0);

		$home = $this->Get_HomeInfo_For_member($userid);
		if( !$home || !$home['home_uid'] ) {
			return $ret;
		}
		$dr_set = ini('rebate_setting');
		$salary_pre = ($home['buy_pre'] > 0 ? $home['buy_pre'] : (($dr_set['buy_pre'] && $dr_set['buy_pre'] > 0) ? $dr_set['buy_pre'] : 0));
		if($salary_pre > 0){
			$time = ($this->time > 0 ? $this->time : time());
			$home_uid   = $home['home_uid'];
			$salary_money = $this->gave_me_money($money, $salary_pre);
			$data = array(
				'uid'   => $userid,
				'uname' => $home['uname'],
				'home_uid' => $home_uid,
				'deal_money' => $money,
				'salary_pre' => $salary_pre,
				'salary_money' => $salary_money,
				'orderid' => $orderid,
				'ticketid' => $ticketid,
				'type' => 'buy',
				'addtime' => $time,
			);
			if(false == $this->_check_exists($data)) {
				$ret = true;
				dbc(DBCMax)->insert('rebate_log')->data($data)->done();
				dbc(DBCMax)->update('members')->data('salary_number=salary_number+'.$money)->where('uid='.(int)$home_uid)->done();
				logic('me')->money()->add($salary_money, $home_uid, array(
					'name' => '뷵',
					'intro' => "ҡ".$home['uname']."ڣ".date('Y-m-d H:i:s', $time)."<br>ѽ&yen;".$money."Ԫ÷&yen;".$salary_money."Ԫ" . ($orderid ? "<br>ţ".$orderid : ""),
				));
				notify($home_uid, 'user.buy.rebate', array(
						'username' => $home['uname'],
						'paytime' => date('Y-m-d H:i:s', $time),
						'paymoney' => $money,
						'rebate_money' => $salary_money,
					));
			}
		}
		return $ret;
	}

	public function Add_Rebate_For_Ticket($product,$uid, $fix_time = false){
        $seller = dbc(DBCMax)->select('seller')->where('`userid`='. (int)$uid)->limit(1)->done();
        if($uid){
            $sellerid = $seller['id'];
        }else{
            $sellerid = $product['sellerid'];
        }
		$orderid = $product['coupon']['orderid'];
		$ticketid = $product['coupon']['ticketid'];
		if($fix_time) {
			$this->time = ($product['coupon']['usetime'] > 0 ? strtotime($product['coupon']['usetime']) : 0);
						if($this->time < 1 || $this->time < $this->_first_time()) return false;
		}
		$mutis = $product['coupon']['mutis'];
		$data_order = dbc(DBCMax)->select('order')->in('productnum,totalprice,expressprice,userid')->where('`orderid`='. $orderid)->limit(1)->done();
		$totalprice = $data_order['totalprice'];
		$productnum = (int)$data_order['productnum'];
		$userid = $data_order['userid'];
		if( $mutis == $productnum ){
			$money = $totalprice - $data_order['expressprice'];
			$fundmoney = $product['fundprice'] * $productnum;
			$score = $productnum * $product['score'];
		}else{
			$money = ($totalprice - $data_order['expressprice']) / $productnum;
			$fundmoney = $product['fundprice'];
			$score = $product['score'];
		}
				if(false != $product['yungou']) {
			$money = $product['price'];
		}
		$ret1 = $this->Add_RebateValue_For_Buyer($userid,$money,$orderid,$ticketid);
		$ret2 = $this->Add_RebateValue_For_Seller($sellerid,$money,$orderid,$ticketid,$fundmoney);
				if($ret1 || $ret2) {
			logic('credit')->add_score($product['id'],$userid,$score);

						$this->__rebate($orderid, $mutis);
		}
				dbc(DBCMax)->update('order')->data(array('comment' => '1'))->where(array('orderid' => $orderid,'comment' => '0'))->done();
	}
	public function Add_Rebate_For_Item($data_order, $fix_time = false){
		$orderid = $data_order['orderid'];
		$productid = $data_order['productid'];
		$totalprice = $data_order['totalprice'];
		$productnum = (int)$data_order['productnum'];
		$userid = $data_order['userid'];
		if($fix_time) {
			$this->time = (ORD_STA_Normal == $data_order['status'] ? max($data_order['paytime'], $data_order['process_time']) : 0);
						if($this->time < 1 || $this->time < $this->_first_time()) return false;
		}
		$data_product = dbc(DBCMax)->select('product')->in('sellerid,fundprice,score,price,yungou')->where('`id`='. $productid)->limit(1)->done();
		$sellerid = $data_product['sellerid'];
		$money = $totalprice - $data_order['expressprice'];		
				if(false != $data_product['yungou']) {
			$money = $data_product['price'];
			$productnum = 1;
		}
		$fundmoney = $data_product['fundprice'] * $productnum;
		$ret1 = $this->Add_RebateValue_For_Buyer($userid,$money,$orderid,$ticketid);
		$ret2 = $this->Add_RebateValue_For_Seller($sellerid,$money,$orderid,$ticketid,$fundmoney);
				$score = $productnum * $data_product['score'];
		if($ret1 || $ret2) {
			logic('credit')->add_score($productid,$userid,$score);

						$this->__rebate($orderid);
		}
				dbc(DBCMax)->update('order')->data(array('comment' => '1'))->where(array('orderid' => $orderid,'comment' => '0'))->done();
	}

	private function __rebate($orderid, $mutis = null) {
		$order = logic('order')->GetOne($orderid);
		if(false == $order || $order['productnum'] < 1) {
			return false;
		}

		$tprice = $order['totalprice'];
		logic('cut')->order_calc($order['orderid'], $tprice, $order['productnum']);
		if($tprice <= 0) {
			return false;
		}

		$this->__rebate_reg($order, $tprice);

		if(is_null($mutis) || $mutis == $order['productnum']) {
			$rprice = $tprice;
		} else {
			$rprice = $tprice / $order['productnum'];
			$order['productnum'] = 1;
		}
		$this->__rebate_buy($order, $rprice);
	}

		private function __rebate_reg($order, $price = null) {
		$reg_money = ini('rebate_setting.reg_money');
		if($reg_money > 0) {
			$uid = (int) $order['userid'];
			$price = (float) (null === $price ? $order['paymoney'] : $price);
			if($uid > 0 && $price > 0) {
				$home_uid = user($uid)->get('home_uid');
				if($home_uid > 0 && logic('order')->Count(" `userid`='{$uid}' AND `paymoney`>'0' AND `pay`='1' ") < 2) {
					logic('me')->money()->add($reg_money, $home_uid, array(
						'name' => 'ע᷵',
						'intro' => 'ţ<b>'.substr((string) $order['orderid'], 0, -4).'****</b><br>
							Ʒ<b>'.$order['product']['flag'].'</b><br>
							֧<b>&yen;'.$price.'Ԫ</b><br>
							עû<b>'.user($uid)->get('name').'</b>עᲢ״Ѻ<br>
							֣<b>'.($reg_money.'Ԫ').'</b><br>'
					));
					notify($home_uid, 'user.buy.rebate', array(
							'username' => user($uid)->get('name'),
							'paytime' => date('Y-m-d H:i:s', time()),
							'paymoney' => $price,
							'rebate_money' => $reg_money,
						));
				}
			}
		}
	}

		private function __rebate_buy($order, $price = null) {
		$uid = (int) $order['userid'];
		$price = (float) (null === $price ? $order['paymoney'] : $price);
		if($uid < 1 || $price <= 0) {
			return ;
		}
		$money = 0;
		$rebate_money = (float) $order['product']['rebate_money'];
		if($rebate_money < 0) {
						return ;
		} elseif (0 == $rebate_money) {
						$buy_rebate = (float) ini('recharge_buy_rebate');
			if($buy_rebate > 0 && $buy_rebate < 100) {
				$money = round($price * $buy_rebate / 100, 2);
                                if($order['productnum'] > 1){
                    $money = $money * $order['productnum'];
                }
			}
		} elseif ($rebate_money > 0) {
						$rebate_limit = (int) $order['product']['rebate_limit'];
			if($rebate_limit > 0) {
				                $count_limit = logic('order')->Count_pro(" `userid`='{$uid}' AND `productid`='{$order['productid']}' AND `pay`='1' AND `orderid`<>'{$order['orderid']}' ");
                				if($count_limit <= $rebate_limit) {
                    $rest_count = intval($rebate_limit-$count_limit);
                    if($order['productnum'] >= 1 && $order['productnum']<=$rest_count){
                        $money = $rebate_money * $order['productnum'];
                    }elseif($rest_count<$order['productnum']){
                        $money = $rebate_money * $rest_count;
                    }else{
                        $money = $rebate_money;
                    }
				}
			} else {
                if($order['productnum'] >= 1){
                    $money = $rebate_money * $order['productnum'];
                }
			}
		}
		if($money > 0) {
			logic('me')->money()->add($money, $uid, array(
				'name' => 'ﷵ',
				'intro' => 'ţ<b>'.$order['orderid'].'</b><br>
					Ʒ<b>'.$order['product']['flag'].'</b><br>
					֧<b>&yen;'.$price.'Ԫ</b><br>
					֣<b>'.($buy_rebate ? $buy_rebate.'%' : $money.'Ԫ').'</b><br>'
			));
		}
	}

	private function gave_me_money($money,$pre100){
						return round(($money * $pre100 / 100), 2);
	}
	
	public function Get_Rebate_setting($toHtml = false){
		$cfg = ini('rebate_setting');
		return $cfg;
	}
	public function Save_Rebate_Setting($data){
	}

	public function get_list_for_me($member_uid){
		$sql = "SELECT * FROM ". table('rebate_log') ." WHERE home_uid='". (int)$member_uid ."' AND `type` != 'master' ORDER BY id DESC";
		$sql = page_moyo($sql);
		$res = dbc(DBCMax)->query($sql)->done();
		if( $res ){
			return $res;
		}else{
			return array();
		}
	}

	public function get_percent($uid){
		$res = dbc(DBCMax)->select('members')->in('buy_pre,sell_pre')->where('`uid`='. (int)$uid)->limit(1)->done();
		if( $res ){
			return array(
				'buy_pre'=>$res['buy_pre'],
				'sell_pre'=>$res['sell_pre'],
			);
		}else{
			return 0;
		}
	}
	public function get_sum_list($uid){
		$sql = 'SELECT uid, uname, SUM(deal_money) AS total_money, SUM(salary_money) AS salary_money FROM ';
		$sql .= table('rebate_log') .' WHERE `home_uid`='. (int)$uid .' AND `type` != "master" GROUP BY `uid`';
		$sql = page_moyo($sql);
		$res = dbc(DBCMax)->query($sql)->done();
		if( !$res ) return 0;
		$uid_list = array();
		foreach ($res as $v) {
			$uid_list[] = $v['uid'];
		}
		$userInfo = dbc(DBCMax)->select('members')->in('uid, regdate, phone')->where('`uid` IN('. implode(',' , $uid_list) .')')->done();
		$sellInfo = dbc(DBCMax)->select('seller')->in('userid, sellername')->where('`userid` IN('. implode(',' , $uid_list) .')')->done();
		$ulist = array();
		$slist = array();
		foreach ($userInfo as $v) {
			$ulist[ $v['uid'] ] = $v;
		}
		if( $sellInfo ){
			foreach ($sellInfo as $v) {
				$slist[ $v['userid'] ] = $v;
			}
		}
		foreach ($res as &$v) {
			$v['regtime'] = $ulist[ $v['uid'] ]['regdate'];
			$v['regtime'] = date('Y/m/d',$v['regtime']);
			$v['phone'] = $ulist[ $v['uid'] ]['phone'];
			if( $slist && $slist[ $v['uid'] ]) $v['is_seller'] = '̻';
			else $v['is_seller'] = 'ͨԱ';
		}
		unset($userInfo);
		unset($ulist);
		unset($slist);
		return $res;
	}
	public function get_anybody_list($uid,$who){
		$sql = 'SELECT * FROM '. table('rebate_log') .' WHERE `uid`='. (int)$who .' AND `home_uid`='. (int)$uid .' AND `type` != "master"';
		$sql = page_moyo($sql);
		$res = dbc(DBCMax)->query($sql)->done();
		if( $res ){
			return $res;
		}else{
			return array();
		}
	}
	public function get_my_rebate_list($where = ''){
		return $this->get_rebate_list($where, MEMBER_ID);
	}

	public function get_rebate_list($where, $uid = null) {
		$sql = "SELECT r.*,t.number,t.mutis,t.usetime,p.flag FROM ". table('rebate_log') ." r
				LEFT JOIN ". table('ticket') ." t ON r.ticketid = t.ticketid
				LEFT JOIN ". table('order') ." o ON r.orderid = o.orderid
				LEFT JOIN ". table('product') ." p ON o.productid = p.id
			WHERE ".(is_null($uid) ? ' 1 ' : " r.uid='". (int) $uid . "' ")." AND r.type='master' ". $where ." ORDER BY r.id DESC";
        $sql = page_moyo($sql);
		$res = dbc(DBCMax)->query($sql)->done();
		if( $res ) {
			return $res;
		}else{
			return array();
		}
	}

	private function _check_exists($data) {
		return (false != dbc(DBCMax)->select('rebate_log')->where(array('orderid'=>$data['orderid'], 'ticketid'=>$data['ticketid'], 'uid'=>$data['uid'], 'type'=>$data['type']))->limit(1)->done());
	}

	private function _first_time() {
		static $_first_time=null;
		if(is_null($_first_time)) {
			$row1 = dbc(DBCMax)->select('rebate_log')->order(' `id` ASC ')->limit(1)->done();
			$_first_time = $row1['addtime'];
		}
		return $_first_time;
	}
}
