<?php
/**
 * @copyright (C)2014 Cenwor Inc.
 * @author Cenwor <www.cenwor.com>
 * @package php
 * @name refund.mod.php
 * @date 2015-09-23 18:07:19
 */





class ModuleObject extends MasterObject
{
	function ModuleObject( $config )
	{
		$this->MasterObject($config);
		$runCode = Load::moduleCode($this);
		$this->$runCode();
	}

	function Main()
	{
		$this->CheckAdminPrivs('refund');
		$status = get('status', 'int');
		$list = logic('refund')->GetList($status);
		include handler('template')->file('@admin/refund_list');
	}

	function Process()
	{
		$this->CheckAdminPrivs('refund');
		$id = get('id', 'number');
		$order = logic('order')->GetOne($id);
		if (!$order)
		{
			$this->Messager(__('Ҳض'), '?mod=order');
		}
		$user 	 = user($order['userid'])->get();
		$payment = logic('pay')->SrcOne($order['paytype']);
		$paylog  = logic('pay')->GetLog($order['orderid'], $order['userid']);
		$coupons = logic('coupon')->SrcList($order['userid'], $order['orderid'], TICK_STA_ANY);
		$express = logic('express')->SrcOne($order['expresstype']);
		$address = logic('address')->GetOne($order['addressid']);
		$refund  = logic('refund')->GetOne($order['orderid']);
                $order['rebate_money'] = $order['product']['rebate_money'] * $order['productnum'];
		$order['ypaymoney'] = ($order['totalprice'] > $order['paymoney']) ? round(($order['totalprice'] - $order['paymoney']),2) : 0;
		$order['tpaymoney'] = $order['totalprice'];
		if($order['product']['type'] == 'ticket'){
			$coupo = logic('coupon')->SrcList($order['userid'], $id);            if($coupo){
                if($order['productnum'] != count($coupo) && $coupo[0]['mutis'] == 1){
                    $order['tpaymoney'] = count($coupo)*$order['productprice'];
                    $order['tmsg'] = array(
                        'money' => $order['paymoney'],
                        'tnum' => $order['productnum'],
                        'num' => $order['productnum']-count($coupo)
                    );
                }
            }else{
                $order['tpaymoney'] = 0;
                $order['tmsg'] = array(
                    'money' => $order['paymoney'],
                    'tnum' => $order['productnum'],
                    'num' => $order['productnum']
                );
            }
		}
		include handler('template')->file('@admin/refund_process');
	}
		function apply()
	{
		$this->CheckAdminPrivs('refund');
		$id = post('oid', 'number');
		$rfm = post('money', 'float');
		$reason = post('reason', 'string');
		$rfm = round($rfm, 2);
		if ($rfm <= 0) {
			$this->Messager('˿');
		}

		if (is_numeric($rfm))
		{
			$remark .= '˿'.$rfm;
		}
		else
		{
			$rfm = null;
		}
		$order = logic('order')->GetOne($id);
		if($id && $order){
			if(ORD_STA_Refund == $order['status']) {
				$this->Messager('öѾ˿ɹظ');
			}
			if($order['product']['type'] == 'ticket'){
				$coupo = logic('coupon')->SrcList($order['userid'], $id);

                if($coupo){
                    if($order['productnum'] != count($coupo) && $coupo[0]['mutis'] == 1){
                        $order['totalprice'] = round(count($coupo)*$order['productprice'], 2);
                    }
                }else{
                    $order['totalprice'] = round(count($coupo)*$order['productprice'], 2);
                }
			}
			if($rfm > $order['totalprice']){
				$this->Messager('˿ܴ'.$order['totalprice']);
			}

			$ret = logic('refund')->check($id);
			if($ret) {
				$__msgs = array(
					-1 => 'ö˿¼ڣ',
					-2 => 'öѾͬ˿ظ',
					-3 => 'öѾܾ˿ظ',
					-4 => 'öѾˣ',
					-5 => 'ö˿',
					-6 => 'öѾ˿ɹظ',
				);
				$this->Messager($__msgs[$ret]);
			}

			logic('refund')->agree($id, $order['userid'], $rfm, $reason);
			logic('order')->clog($id)->add('refund', $remark);
			logic('order')->Refund($id, $rfm);

			if(false !== ($cash = logic('refund')->cash($id))) {
				$this->Messager('ͬԭ·˿ɹ!Ϊתֲҳ', 'admin.php?mod=cash&code=order&orderid=' . $cash['orderid']);
			} else {
				$this->Messager('ͬ˿ɹ!', 'admin.php?mod=refund');
			}
		}else{
			$this->Messager('');
		}
	}

		function refuse()
	{
		$this->CheckAdminPrivs('refund');
		$id = post('oid', 'number');
		$reason = post('reason', 'string');
		if (empty($reason)) {
			$this->Messager('дܾԭ');
		}

		$order = logic('order')->GetOne($id);
		if($id && $order){
			$ret = logic('refund')->check($id);
			if($ret) {
				$__msgs = array(
					-1 => 'ö˿¼ڣ',
					-2 => 'öѾͬ˿ظ',
					-3 => 'öѾܾ˿ظ',
					-4 => 'öѾˣ',
					-5 => 'ö˿',
					-6 => 'öѾ˿ɹظ',
				);
				$this->Messager($__msgs[$ret]);
			}

			logic('refund')->refuse($id, $order['userid'], $reason);
			$this->Messager('ܾ˿ɹ!', 'admin.php?mod=refund');
		}else{
			$this->Messager('');
		}
	}
}


?>