<?php
/**
 * @copyright (C)2014 Cenwor Inc.
 * @author Cenwor <www.cenwor.com>
 * @package php
 * @name creditmall.mod.php
 * @date 2015-01-30 15:10:51
 */
 


class ModuleObject extends MasterObject {

	public $is3g = '';
	public $tplid = '';
	public $user = array();

	public function ModuleObject( $config ) {
		global $rewriteHandler;
		$rewriteHandler = null;

		$this->MasterObject($config);
		$runCode = Load::moduleCode($this);

		if(false == logic('creditmall')->is_open) {
			exit('creditmall is closed');
		}

		$this->is3g = ($_REQUEST['3g'] ? 1 : 0);
		if($this->is3g) {
			$this->tplid = '_3g';
		}
		$this->_init_user();

		$this->$runCode();
	}

	public function Main() {
		exit('request uri is error');
			}

	public function goods_list() {
		$this->Title = '̳ҳ';

		$params = array('expire_min' => strtotime(date('Y-m-d')));
		$price_max = get('price_max', 'int');
		if($price_max > 0) {
			$params['price_max'] = $price_max;
			$this->Title = 'ܶһƷб';
		}
		$list = logic('creditmall')->goods()->get_list($params);

		include handler('template')->file('@creditmall/goods_list' . $this->tplid);
	}

	public function goods_info() {
		$id = get('id', 'int');
		if($id < 1 || false == ($one = logic('creditmall')->goods()->get_one($id))) {
			$this->_msg('ƷѾ');
		}

		$this->Title = 'Ʒ';
		include handler('template')->file('@creditmall/goods_info' . $this->tplid);
	}

	public function order_create() {
		$id = (int) $_REQUEST['id'];
		if($id < 1 || false == ($one = logic('creditmall')->goods()->get_one($id))) {
			$this->_msg('ƷѾ');
		}

		if(false != ($data = post('data'))) {
			$ret = logic('creditmall')->order()->create(array(
					'uid' => $this->user['id'],
					'goods_id' => $id,
					'address' => $data['address'],
					'tel' => $data['tel'],
					'qq' => $data['qq']
				));
			if($ret) {
				$this->_msg($ret);
			} else {
				$this->_msg('', '?mod=creditmall&code=order&op=list&3g=1');
			}
		} else {
			$last = logic('creditmall')->order()->get_last($this->user['id']);
		}

		$this->Title = 'һƷ';
		include handler('template')->file('@creditmall/order_create' . $this->tplid);
	}

	public function order_list() {
		$list = logic('creditmall')->order()->get_list(array(
				'uid' => $this->user['id']
			));

		$this->Title = 'һ¼';
		include handler('template')->file('@creditmall/order_list' . $this->tplid);
	}

	public function order_info() {
		$id = get('id', 'number');
		if($id < 1 || false == ($one = logic('creditmall')->order()->get_one($id, true))) {
			$this->_msg('Ѿ');
		}
		if($one['uid'] != $this->user['id']) {
			$this->_msg('ûȨ޲鿴ö');
		}

		$this->Title = '';
		include handler('template')->file('@creditmall/order_info' . $this->tplid);
	}

	public function credit_list() {
		$list = logic('credit')->get_list_for_me($this->user['id']);

		$this->Title = 'ҵĻ';
		include handler('template')->file('@creditmall/credit_list' . $this->tplid);
	}

	public function signin() {
		$ret = logic('signin')->signin($this->user['id']);

		$rets = array(
			'1' => 'ϲ<i>'.logic('signin')->notice['today_credit'].'</i>֣ǩɻ<i>'.logic('signin')->notice['nextday_credit'].'</i>֣',
			'0' => 'ǩͻֵĹδ',
			'-1' => 'ȵ¼עһ˺',
			'-2' => 'Ѿǩ<i>'.logic('signin')->notice['signin_day'].'</i>죬ǩɻ<i>'.logic('signin')->notice['nextday_credit'].'</i>',
			'-3' => 'ǩͻֵĹδûΪ',
		);
		$ret_msg = ($rets[$ret] ? $rets[$ret] : 'δ֪');

		$this->Title = 'ǩͻ';
		include handler('template')->file('@creditmall/signin' . $this->tplid);
	}

	private function _msg($msg = '', $to = '') {
		if(empty($msg)) {
			if($to) {
				header('Location: ' . $to);
			}
		}

		$this->Title = 'Ϣʾ';
		include handler('template')->file('@creditmall/msg' . $this->tplid);
		exit;
	}

	private function _init_user() {
		$api_uid = api_uid();
		if($api_uid < 1) {
			$this->_msg('Ҫȵ¼ܼ');
		}
		$this->user = user($api_uid)->get();
		if(false == $this->user || $this->user['id'] < 1) {
			$this->_msg('Ҫȵ¼ܼ');
		}
	}

}